stages:
  - prepare-release
  - publish-release

prepare:
  image: node:16-alpine
  stage: prepare-release
  # Only if I create a tag
  rules:
    - if: $CI_COMMIT_TAG
  artifacts:
    paths:
      - awesome-app-release.js
    expire_in: 1 hour
    reports:
      dotenv: release.env
  script: |
    apk --no-cache add curl
    # fake a buil process
    cp awesome-app.js awesome-app-release.js
    # store variable(s)
    RELEASE_PATH=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/\
    ${CI_PROJECT_NAME}/${CI_COMMIT_TAG}/awesome-app-${CI_COMMIT_TAG}-release.js

    echo "RELEASE_PATH=$RELEASE_PATH" > release.env

    # then publish it to the generic registry
    curl --header "JOB-TOKEN:$CI_JOB_TOKEN" \
         --upload-file awesome-app-release.js \
         "$RELEASE_PATH"

publish:
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  stage: publish-release
  # Only if I create a tag
  rules:
    - if: $CI_COMMIT_TAG
  variables:
    # RELEASE_PATH is read from release.env
    release_asset_link: |
      {
        "name":"Awesome Application version ${CI_COMMIT_TAG}",
        "url":"${RELEASE_PATH}"
      }
  script: |
    release-cli create \
      --name "🚀 Awesome Application version ${CI_COMMIT_TAG}" \
      --description "Release of Awesome Application version ${CI_COMMIT_TAG}"\
      --assets-link "${release_asset_link}"

